; =========================================================;
;                                                          ;
;      hid.h for Easy Code 2.0 64-bit GoAsm projects       ;
;                   (version 1.0.0)                        ;
;                                                          ;
;              Copyright  Ramon Sala - 2022               ;
;                                                          ;
; =========================================================;

#IFNDEF HID_INC
#DEFINE HID_INC    1

#DEFINE DATA_SIZE_MASK                                  0x03
#DEFINE TYPE_MASK                                       0x0C
#DEFINE TAG_MASK                                        0xF0

#DEFINE DATA_SIZE_0                                     0x00
#DEFINE DATA_SIZE_1                                     0x01
#DEFINE DATA_SIZE_2                                     0x02
#DEFINE DATA_SIZE_4                                     0x03

#DEFINE TYPE_MAIN                                       0x00
#DEFINE TYPE_GLOBAL                                     0x04
#DEFINE TYPE_LOCAL                                      0x08

#DEFINE TAG_MAIN_INPUT                                  0x80
#DEFINE TAG_MAIN_OUTPUT                                 0x90
#DEFINE TAG_MAIN_COLLECTION                             0xA0
#DEFINE TAG_MAIN_FEATURE                                0xB0
#DEFINE TAG_MAIN_ENDCOLLECTION                          0xC0

#DEFINE TAG_GLOBAL_USAGEPAGE                            0x00
#DEFINE TAG_GLOBAL_LOGICALMIN                           0x10
#DEFINE TAG_GLOBAL_LOGICALMAX                           0x20
#DEFINE TAG_GLOBAL_PHYSMIN                              0x30
#DEFINE TAG_GLOBAL_PHYSMAX                              0x40
#DEFINE TAG_GLOBAL_UNITEXP                              0x50
#DEFINE TAG_GLOBAL_UNIT                                 0x60
#DEFINE TAG_GLOBAL_REPORTSIZE                           0x70
#DEFINE TAG_GLOBAL_REPORTID                             0x80
#DEFINE TAG_GLOBAL_REPORTCOUNT                          0x90
#DEFINE TAG_GLOBAL_PUSH                                 0xA0
#DEFINE TAG_GLOBAL_POP                                  0xB0

#DEFINE TAG_LOCAL_USAGE                                 0x00
#DEFINE TAG_LOCAL_USAGEMIN                              0x10
#DEFINE TAG_LOCAL_USAGEMAX                              0x20

#DEFINE HID_GET_REPORT                                  0x01
#DEFINE HID_GET_IDLE                                    0x02
#DEFINE HID_GET_PROTOCOL                                0x03
#DEFINE HID_SET_REPORT                                  0x09
#DEFINE HID_SET_IDLE                                    0x0A
#DEFINE HID_SET_PROTOCOL                                0x0B

#DEFINE HID_HID_DESCRIPTOR_TYPE                         0x21
#DEFINE HID_REPORT_DESCRIPTOR_TYPE                      0x22
#DEFINE HID_PHYSICAL_DESCRIPTOR_TYPE                    0x23

#DEFINE HID_SUBCLASS_NONE                               0
#DEFINE HID_SUBCLASS_BOOT_INTERFACE                     1

#DEFINE HID_PROTOCOL_NONE                               0x00
#DEFINE HID_PROTOCOL_KEYBOARD                           0x01
#DEFINE HID_PROTOCOL_MOUSE                              0x02

#DEFINE HID_BOOT_PROTOCOL                               0x00
#DEFINE HID_RPT_PROTOCOL                                0x01

#DEFINE HID_REPORT_TYPE_INPUT                           1
#DEFINE HID_REPORT_TYPE_OUTPUT                          2
#DEFINE HID_REPORT_TYPE_FEATURE                         3

#DEFINE HID_REQUEST_GET_REPORT                          0x01
#DEFINE HID_REQUEST_GET_IDLE                            0x02
#DEFINE HID_REQUEST_GET_PROTOCOL                        0x03
#DEFINE HID_REQUEST_SET_REPORT                          0x09
#DEFINE HID_REQUEST_SET_IDLE                            0x0A
#DEFINE HID_REQUEST_SET_PROTOCOL                        0x0B

#DEFINE HID_DESCRIPTOR_HID                              0x21
#DEFINE HID_DESCRIPTOR_REPORT                           0x22
#DEFINE HID_DESRIPTOR_PHY                               0x23

#DEFINE HID_INTF                                        0x03

#DEFINE HID_BOOT_INTF_SUBCLASS                          0x01


#DEFINE HID_ITEM_TYPE_MAIN                              0
#DEFINE HID_ITEM_TYPE_GLOBAL                            1
#DEFINE HID_ITEM_TYPE_LOCAL                             2
#DEFINE HID_ITEM_TYPE_RESERVED                          3

#DEFINE HID_LONG_ITEM_PREFIX                            0xFE

#DEFINE bmHID_MAIN_ITEM_TAG                             0xFC

#DEFINE bmHID_MAIN_ITEM_INPUT                           0x80
#DEFINE bmHID_MAIN_ITEM_OUTPUT                          0x90
#DEFINE bmHID_MAIN_ITEM_COLLECTION                      0xA0
#DEFINE bmHID_MAIN_ITEM_FEATURE                         0xB0
#DEFINE bmHID_MAIN_ITEM_END_COLLECTION                  0xCE

#DEFINE HID_MAIN_ITEM_COLLECTION_PHYSICAL               0
#DEFINE HID_MAIN_ITEM_COLLECTION_APPLICATION            1
#DEFINE HID_MAIN_ITEM_COLLECTION_LOGICAL                2
#DEFINE HID_MAIN_ITEM_COLLECTION_REPORT                 3
#DEFINE HID_MAIN_ITEM_COLLECTION_NAMED_ARRAY            4
#DEFINE HID_MAIN_ITEM_COLLECTION_USAGE_SWITCH           5
#DEFINE HID_MAIN_ITEM_COLLECTION_USAGE_MODIFIER         6

#ENDIF ;HID_INC
